#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    1280
#define SCREEN_HEIGHT   720

float process(float r, int n)
{
    float x = 0.5f;

    for (int i = 0; i < n; i++)
        x = r * x * (1 - x);

    return x;
}

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Logistic 3", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    int t = 0;
    float startR = 2.3f;
    float endR   = 4.0f;

    while (sys.isQuitRequested() == false)
    {
        if (t < SCREEN_WIDTH)
        {
            for (int i = 0; i < 150; i++)
            {
                float r = startR + (endR - startR) * t / (SCREEN_WIDTH - 1);
                float x = process(r, 10000 + i);
                float y = (1 - x) * (SCREEN_HEIGHT - 1);
                gfx.setPixel(t, y, Color(255, 255, 255));
            }

            t++;
        }

        gfx.render();
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
